package xyz.etztech.minecraftmanager;

import org.apache.commons.lang.StringUtils;
import org.bukkit.Bukkit;

import java.util.HashMap;
import java.util.Map;

public class MCMAPI {
    private static String url;
    private static String api;

    /**
     * Turns on testing mode
     * @param url The override Django API URL
     * @param api The override Django API password
     */
    public static void test(String url, String api) {
        MCMAPI.url = url;
        MCMAPI.api = api;
    }

    private static void log(String message) {
        try {
            Bukkit.getConsoleSender().sendMessage(message);
        } catch (Exception ex) {
            System.out.println(message);
        }
    }

    public static Map<String, String> setup() {
        Map<String, String> data = new HashMap<>();
        if (StringUtils.isNotEmpty(MCMAPI.api)) {
            data.put("api", MCMAPI.api);
        } else {
            data.put("api", MinecraftManager.config.getString("django.api"));
        }
        return data;
    }




    /**
     * @return The Django API URL ending with a slash
     */
    public static String getDjangoUrl() {
        if (StringUtils.isNotEmpty(MCMAPI.url)) {
            return MCMAPI.url;
        } else {
            String configUrl = MinecraftManager.config.getString("django.url");
            return configUrl.endsWith("/") ? configUrl : configUrl + "/";
        }
    }

    public static String getModelUrl(String model) {
        return getDjangoUrl() + "model/" + model + "/";
    }
}
